import 'package:flutter/material.dart';
import 'package:http/http.dart' as http;
import 'package:purchases_flutter/purchases_flutter.dart';
import 'package:shared_preferences/shared_preferences.dart';
import 'package:webview_flutter/webview_flutter.dart';
import 'ConscentInitializer.dart';
import 'ConscentMethods.dart';
import 'Model/APIMode.dart';
import 'Model/loginChallengeget.dart';
import 'SharedPref.dart';
import 'package:purchases_flutter/purchases_flutter.dart' as purchases;
import 'package:purchases_flutter/models/purchases_configuration.dart';

void main() {
  runApp(
    const MaterialApp(
      home: WebViewAppss(),
    ),
  );
}

class WebViewAppss extends StatefulWidget {
  const WebViewAppss({super.key});

  @override
  State<WebViewAppss> createState() => _WebViewAppStates();
}

class _WebViewAppStates extends State<WebViewAppss> {
  String? loginId;
  // Add from here ...
  bool showContent = false;
  final clientId = TextEditingController();
  final clientContentId = TextEditingController();
  final _configuration =
      PurchasesConfiguration('appl_NKgaWHAdRrBYjFiuGYtskFLtaaI');
  bool isSubscribed = false;
  int coins = 0;
  String? content_69_1month;
  String? content_49_1month;
  bool showContents = false;
  bool isLoaded = false;

  String? subsUrl;
  @override
  void initState() {
    if (mounted) {
      getLoginChallengeId();
    }
    super.initState();
  }

  // dynamic dataMain;
  getLoginChallengeId() async {
    subsUrl = await SharedPref().getSubsUrl();
    final prefs = await SharedPreferences.getInstance();
    loginId = prefs.getString('loginID');
    print(loginId.toString());
    getSessionID(loginId.toString());
    setState(() {});
  }

  Future<String> getSessionID(String loginId) async {
    print('getSessionId------');
    var uri = Uri.parse('${APIMode.BASE_URL}api/v1/login-challenge/$loginId');
    print(uri);
    var response = await http.get(uri);
    if (response.statusCode == 200) {
      LoginChallengeget loginChallengeget =
          loginChallengegetFromJson(response.body);
      final prefs = await SharedPreferences.getInstance();
      print('WebViewApp sessionId ${prefs.getString('sessionId')}');
      String sessionId = loginChallengeget.toString();
      prefs.setString('sessionId', sessionId);
      print(loginChallengeget.toJson());
      CircularProgressIndicator();
      return sessionId;
    } else {
      ConscentMethods().onPluginError(response.body);
    }
    return '';
  }

  Future<void> submitDatas(
      String clientId, String clientContentId, String sessionId) async {
    print('sessionId xyz= $sessionId');
    var response = await http
        .post(Uri.parse('${APIMode.BASE_URL}api/v1/content/access'), body: {
      "clientId": clientId,
      "clientContentId": clientContentId,
      "sessionId": sessionId,
    });
    print('-------------------------------------------------------');
    print('${response.body}---- status---${response.statusCode}');

    if (response.statusCode == 201) {
      var responseString = response.body;
      Navigator.pop(context, {"response": responseString});
    } else {
      ConscentMethods().onPluginError(response.body);
    }
  }

  JavascriptChannel _javascriptChannel() {
    print('javascript');
    return JavascriptChannel(
        name: 'LOGINCHALLENGE',
        onMessageReceived: (JavascriptMessage message) async {
          print(message.message);
          if (message.message == 'loginSuccess') {
            CircularProgressIndicator();
            print('javascript----------');
            String sessionId = await getSessionID(loginId!);
            submitDatas('${ConscentInitializer.mClientId}',
                '${ConscentInitializer.mContentId}', sessionId);
          }
        });
  }

  JavascriptChannel _javascriptChannels() {
    print('APPLEPAY');
    return JavascriptChannel(
        name: 'APPLEPAY',
        onMessageReceived: (JavascriptMessage message) async {
          if (message.message == 'callbackHandler') {
            // var data = message.message;
            // data = message.message;

            Icon(isSubscribed ? Icons.paid : Icons.lock);
            Text('$coins');
            const SizedBox(height: 10);
            if (content_49_1month == 'content_49_1month') {
              try {
                await Purchases.purchaseProduct('content_49_1month');
                setState(() => coins += 49);
                print('content_49_1month');
                String sessionId = await getSessionID(loginId!);
                submitDatas('${ConscentInitializer.mClientId}',
                    '${ConscentInitializer.mContentId}', sessionId);
              } catch (e) {
                debugPrint('Failed to purchase product');
              }
            } else if (content_69_1month == 'content_69_1month') {
              try {
                await Purchases.purchaseProduct('content_69_1month');
                setState(() => coins += 69);
                print('content_69_1month');
                String sessionId = await getSessionID(loginId!);
                submitDatas('${ConscentInitializer.mClientId}',
                    '${ConscentInitializer.mContentId}', sessionId);
              } catch (e) {
                debugPrint('Failed to purchase product');
              }
            } else {
              try {
                await Purchases.purchaseProduct('content_101_1m');
                setState(() => coins += 101);
                print('content_101_1m');
                String sessionId = await getSessionID(loginId!);
                submitDatas('${ConscentInitializer.mClientId}',
                    '${ConscentInitializer.mContentId}', sessionId);
              } catch (e) {
                debugPrint('Failed to purchase product');
              }
            }
          }
        });
  }

  @override
  Widget build(BuildContext context) {
    javascriptChannels:
    <JavascriptChannel>{_javascriptChannel(), _javascriptChannels()};
    var flutterWebViewPlugin;
    print(loginId);

    return Scaffold(
      appBar: AppBar(
        title: const Text('Conscent'),
      ),
      body: loginId != null
          ? WebView(
              initialUrl: subsUrl,
              javascriptMode: JavascriptMode.unrestricted,
              onProgress: (int progress) async {
                javascriptChannels:
                <JavascriptChannel>{
                  _javascriptChannel(),
                  _javascriptChannels()
                };
                print('WebView is loading (progress : $progress%)');
              },
              onWebViewCreated: (controller) {
                print('---onWebViewCreated----${controller.currentUrl()}');
              },
              navigationDelegate: (NavigationRequest request) {
                print('----navigation delegate---${request.url}');
                //    javascriptChannels: <JavascriptChannel>{_javascriptChannel()};
                if (request.url.startsWith('https://xyz.zyz')) {
                  //    javascriptChannels: <JavascriptChannel>{_javascriptChannel()};
                  print('APIU CALL FIRST');
                  //    getSessionID(loginId.toString());
                  //   submitDatas(clientId.text, clientContentId.text,sessionId);
                  getSessionID(loginId!);
                  //  7500757759

                  return NavigationDecision.prevent;
                } else if (request.url.startsWith(
                    '${APIMode.SERVICE_BASE_URL}/?csc-tierId=619b7f6cfbacc96bd8fb232a')) {
                  //      .startsWith('https://conscentsss.com/?csc-tierId=${widget.tiersId})')){
                  Navigator.pop(context);
                }

                print('allowing navigation to $request');
                return NavigationDecision.navigate;
              },
              onPageStarted: (String url) {
                print('Page started loading: $url');
              },
              onPageFinished: (String url) {
                print('Page finished loading: $url');
              },
              javascriptChannels: <JavascriptChannel>{
                _javascriptChannel(),
                _javascriptChannels()
              },
            )
          : Center(child: CircularProgressIndicator()),
    );
  }
}
